#import "SPApplication.h"
#import "SPWindow.h"

@implementation SPApplication

- ( void )sendEvent: ( NSEvent * )event
{
    NSEventType		type = [ event type ];
    
    if ( type != NSAppKitDefined &&
                type != NSSystemDefined &&
                type != NSApplicationDefined ) {
        NSLog( @"got event, quitting screen preserver" );
		[NSCursor unhide];

		NSEnumerator *e = [[self windows] objectEnumerator];
		SPWindow *window;
		while( window = [e nextObject] ) {
			[window close];
		}

		NSURL *scriptURL = [NSURL fileURLWithPath:[[NSBundle mainBundle] pathForResource:@"runatquit" ofType:@"scpt"]];
		NSAppleScript *theScript = [[NSAppleScript alloc] initWithContentsOfURL:scriptURL error:nil];
		[theScript executeAndReturnError:nil];
		[theScript release];

        exit( 0 );
    } else {
        [ super sendEvent: event ];
    }
}

@end
