##!/usr/bin/perl -w
#
##perl -pi -e's/^#//' /var/radmind/client/xhooks/download_overload.pl; cp /var/radmind/client/xhooks/download_overload.pl /usr/local/bin/download_overload.pl; chmod 755 /usr/local/bin/download_overload.pl
##/usr/local/bin/download_overload.pl -h example.com overload_name.T
#
#################################################################################
## Copyright (c) 2005 University of Utah Student Computing Labs.
## All Rights Reserved.
##
## Permission to use, copy, modify, and distribute this software and
## its documentation for any purpose and without fee is hereby granted,
## provided that the above copyright notice appears in all copies and
## that both that copyright notice and this permission notice appear
## in supporting documentation, and that the name of The University
## of Utah not be used in advertising or publicity pertaining to
## distribution of the software without specific, written prior
## permission. This software is supplied as is without expressed or
## implied warranties of any kind.
#################################################################################
#
#die "Run me as root.\n" if $> ne 0;
#
## If you would like to use this script without having to install all of Xhooks
## just comment out the next 2 lines and set the variables right below it:
#
#if ( -e "/Library/Xhooks/Modules/xhooks/lib/config.pl" ) {
#  use lib "/Library/Xhooks/Modules";
#  require "xhooks/lib/config.pl";
#}
#
#if ( -f "/Library/Preferences/Xhooks/edu.utah.scl.radmind_xhooks_conf.perl" ) {
#  use lib "/Library/Preferences/Xhooks";
#  require "edu.utah.scl.radmind_xhooks_conf.perl";
#}
#
#################################################################################
## download_overload.pl
##
## This script will download an overload out of context.  See the usage function
## below for more instructions.
##
## 1.0.6 2008.05.02 It now uses Xhooks paths and variables.
## 1.0.5 2006.09.25 Made it smarter so it wouldn't die if entman wasn't present (minimally tested)
##                  Can now specify the radmind server on the command line.
##                  Supports server auth mode (untested)
##                  specify checksum from command line--n still means no checksum (untested)
## 1.0.4 2005.07.12 Made it not delete anything.  Updated to be used in entman.
##                  Added support for multiple overloads.
## 1.0.3 2004.05.06 Switched to ulabmin radmind config file.
##                  Added n option.
##                  Added other stuff
## 1.0.2 2004.01.28 Fixed a few things.
## 1.0.1 2004.01.28 Added a flag to auto run ktcheck.
##       2004.01.28 Streamlined the transcript checking section.
##
#################################################################################
#
#use Getopt::Std;
#
#####################################
## Get ARGs
##
#getopts("ac:fh:Iknw:",\%options);
#
#my $fsdiffpath;
#my $lapply_options = "";
#my $ktcheck_options = "";
#my $fsdiff_options = "";
#
#if ( defined $options{'a'} ) {
#  $fsdiffpath = "/";
#  chdir "/";
#} else {
#  $fsdiffpath = ".";
#}
#if ( defined $FSDIFF_PATH ) {
#  $fsdiffpath = $FSDIFF_PATH;
#}
#
#if ( ! defined $options{'c'} and ! ( defined $options{'n'} or ( defined $RADMIND_CHECKSUM and $RADMIND_CHECKSUM eq "False" ) ) ) {
#  # This is the default behavior (no variable or no flag)
#  $lapply_options .= " -c sha1";
#  $fsdiff_options .= " -c sha1";
#} elsif (defined $options{'c'}) {
#  $lapply_options .= " -c ".$options{'c'};
#  $fsdiff_options .= " -c ".$options{'c'};
#}
#
#if ( defined $options{'I'} or ( defined $CASE_SENSITIVE and $CASE_SENSITIVE eq "False" ) ) {
#  # case insenstive now!
#  $lapply_options .= " -I"; 
#  $fsdiff_options .= " -I";
#}
#
#if ( defined $RADMIND_PORT ) {
#  $ktcheck_options .= " -p $RADMIND_PORT";
#  $lapply_options .= " -p $RADMIND_PORT";
#}
#
#if ( defined $RADMIND_AUTH_LEVEL and ! defined $options{'w'} ) {
#  $ktcheck_options .= " -w $RADMIND_AUTH_LEVEL";
#  $lapply_options .= " -w $RADMIND_AUTH_LEVEL";
#} elsif ( defined $options{'w'} ) {
#  $ktcheck_options .= " -w $options{'w'}";
#  $lapply_options .= " -w $options{'w'}";
#}
#
#if ( defined $RADMIND_COMPRESSION_LEVEL ) {
#  $ktcheck_options .= " -Z $RADMIND_COMPRESSION_LEVEL";
#  $lapply_options .= " -Z $RADMIND_COMPRESSION_LEVEL";
#}
#
#if ( defined $options{'h'} ) {
#  $radmind_server = $options{'h'};
#} else {
#  if ( defined $RADMIND_SERVERS[0] and $RADMIND_SERVERS[0] ne "" ) {
#    $radmind_server = $RADMIND_SERVERS[0];
#  } else {
#    print "No radmind server set.  Use -h to manually specify a server or make sure the settings are readable.\n";
#    usage();
#  }
#}
#if ( ! defined $RADMIND_FOLDER ) {
#  $RADMIND_FOLDER = "/var/radmind/client";
#}
#
#
#####################################
## Other settings
##
#$ignore_all_transcript = "admin_ignore_all.T";
#$location_of_temp_transcript = "$RADMIND_FOLDER/temp_command.K";
## Generated from the above variables
#$fsdiff_command = "/usr/local/bin/fsdiff -A $fsdiff_options -K $location_of_temp_transcript $fsdiffpath";
#$lapply_command = "/usr/local/bin/lapply -F $lapply_options -h $radmind_server";
#
#@transcripts = ();
#foreach $i ( @ARGV ) {
#  push @transcripts, get_overload_name( $i );
#}
#
#####################################
## Test stuff.
#
#if ($#transcripts eq "-1") {
#  usage();
#}
#
#if (! -w $RADMIND_FOLDER) {
#  print "Can not write to $RADMIND_FOLDER. $!\n";
#  usage();
#}
#
#####################################
## Check for a situtation that will probably error out.
##if (chomp (`pwd`) ne "/" and $fsdiffpath eq "." and ! defined $options{'f'}) {
##  print "This Mac is using relative paths, is not creating missing folders,";
##  print " and is not located at the root of the volume.  Are you sure you want to continue?\n";
#  # put something here.
##}
#
#####################################
## Run ktcheck if needed.
#if (defined $options{'k'}) { # run ktcheck
#  print "Running ktcheck\n";
#  print "/usr/local/bin/ktcheck -c sha1 $ktcheck_options -h $radmind_server\n";
#  system "/usr/local/bin/ktcheck -c sha1 $ktcheck_options -h $radmind_server";
#}
#
#####################################
## Check for transcript and run ktcheck if needed.
#foreach $transcript ( @transcripts ) {
#  while (! -e "$RADMIND_FOLDER/$transcript") {
#    print "Could not find $RADMIND_FOLDER/$transcript\n";
#    print "If the command file on the server does not include the desired overload, you will not be able to download it.\n";
#    if (! ask_y_n_question("Do you want me to run ktcheck and try to download the transcript?\n")) {
#      print "Exiting.\n";
#      exit 1;
#    }
#    print "Running ktcheck\n";
#    print "/usr/local/bin/ktcheck -c sha1 $ktcheck_options -h $radmind_server\n";
#    system "/usr/local/bin/ktcheck -c sha1 $ktcheck_options -h $radmind_server";
#  }
#}
#
#
#
#####################################
## GO
#
###
## Create blank negative
#system "/bin/echo \"d $fsdiffpath 0755 0 0\" > $RADMIND_FOLDER/$ignore_all_transcript";
#
###
## Create command file
#unlink $location_of_temp_transcript if -e $location_of_temp_transcript;
#foreach $transcript ( @transcripts ) {
#  $_ = $transcript;
#  if ( /.K$/ ) {                    
#    system "/bin/echo \"k $transcript\" >> $location_of_temp_transcript"; 
#  } else {
#    system "/bin/echo \"p $transcript\" >> $location_of_temp_transcript";
#  }
#}
#system "/bin/echo \"n $ignore_all_transcript\" >> $location_of_temp_transcript";
#
###
## Run fsdiff | lapply
#
#if (defined $options{'f'}) { # create missing folders
#  
#  ##
#  # run fsdiff
#  print "$fsdiff_command | grep -v \"^-\"\n";
#  open (COMMAND, "$fsdiff_command | grep -v \"^-\" | ");
#
#  my $dirpath;
#
#  $fsdiff_output_send_to_lapply = "";
#  # Loop through the input (which should be fsdiff)
#  # Taken straight from lapply_crutch with only STDIN modified to be <>
#  while ( $input = <COMMAND>) { 
#    @info = split (' ', $input);
#    $number = @info;
#    if ($number > 2) {
#      if ($info[1] ne "") {
#        if ($info[0] eq "d") {
#          $path = $info[1];
#          $path =~ s/\\b/ /g;;
#          $dirpath = $path;
#        } else {
#          if ($info[0] eq "-" || $info[0] eq "+") {
#            $path = $info[2];
#          } else {
#            $path = $info[2];
#          }
#          $path =~ s/\\b/ /g;;
#  
#          @folders = split ('/', $path);
#          $depth = @folders;
#          $dirpath = "";
#          for ($i = 0 ; $i < $depth - 1 ; $i++) {
#            $dirpath .= $folders[$i]. "/";
#          }
#          chop $dirpath;
#        }
#        if ($dirpath ne "" and ! -e $dirpath) {
#          print "creating directory $dirpath\n";
#          system "/bin/mkdir -p \"$dirpath\"";
#        }
#      }
#    }
#    $fsdiff_output_send_to_lapply .= $input;
#  }
#  close (COMMAND);
#
#  ##
#  # run lapply
#  print "$lapply_command\n";
#  open (COMMAND, "| $lapply_command");
#  print COMMAND $fsdiff_output_send_to_lapply;
#  print STDOUT $fsdiff_output_send_to_lapply;
#  close (COMMAND);
#} else {
#  print "$fsdiff_command | grep -v \"^-\" | $lapply_command\n";
#  system "$fsdiff_command | grep -v \"^-\" | $lapply_command";
#}
#
## if anything was downloaded to /Users/mac/Admin/guest, ask if you want to recreate the home folder caches!
#
#
#exit 0;
#
#################################################################################
## Verify overload exists and is valid
#sub get_overload_name {
#  my ($overload_name) = @_;
#  if ( $overload_name eq "" ) {
#    print "Please enter the overload name.\n";
#    return -1;
#  }
#  return $overload_name
#}
#
#################################################################################
## Just asks 3 times if the user wants to quit or continue
#sub ask_y_n_question {
#  ($message) = @_;
#  $tempy = 0;
#  do {
#    $tempy++;
#    print "$message (y/n)? ";
#    chop($iwanna = <STDIN>);
#    if ($iwanna eq "y" || $iwanna eq "Y") {
#      return 1;
#    } elsif ($iwanna eq "n" || $iwanna eq "N") {
#      return 0;
#    }
#  } while ($tempy < 4);
#  return 0;
#}
#
#################################################################################
#sub usage {
#  my $myname = `basename $0`;
#  print STDERR << "EOF";
#Usage: $myname [-afkn] [-w checksum_type] [-h radmind.server.edu] [-w auth_level] overload_name [overload_name...]
#
#examples:
#
#	$myname some_app.T
#	$myname -h radmind.bombschool.edu how_to.T how_not_to.T
#
#-a Use absolute paths instead of relative (relative is default).
#   Absolute paths were an afterthought.  Maybe they work, maybe not...
#-f Create folders that are missing from the transcript rather than bail out.
#-I Case insensititive
#-k Run ktcheck without asking (use with ARD and Send Unix command).
#-n Don't use checksum.
#
#-c Specify the checksum type (see radmind tool man pages for checksums supported) (untested).
#-h Specify the radmind server.
#-w Specify an auth level (untested).
#
#This script downloads all transcripts specified.  The last transcript has
#precedence.  This script will not delete files (all - lines are removed).
#
#If your transcript specifies folders that don't exist, use the -f flag to create
#them.
#
#Relative paths are cool.  You can switch your transcripts to use them on the client
#(if you use absolute paths) and then you can download overloads to any folder you
#want (the cwd).
#
#This script works by creating a command file with a negative transcript that ignores
#everything.  When fsdiff runs with that command file, it, well, ignores everything!
#But then you add transcripts on top of that, it will effectively ignore everything
#BUT the listed transcipts.  So you can download transcripts at will.
#
#(instructions last updated 2006.09.25)
#
#EOF
#    exit 1;
#}
