$make_hidden_visible = "/Library/Preferences/Xhooks/edu.utah.scl.secure/make_hidden_visible";

sub unrestrict_folders_files {
  my ( @file_folder_list ) = @_;
  if ( -e $make_hidden_visible ) {
    system "/bin/sh", "$make_hidden_visible";
    unlink $make_hidden_visible;
  }

}

sub restrict_folders_files {
  my ( @file_folder_list ) = @_;
  if ( -e $make_hidden_visible ) {
    return; # already hidden
  }
  my $file_folder;
  my %hidden_stuff = ();
  foreach $file_folder ( @file_folder_list ) {
    if ( ! defined $hidden_stuff{$file_folder} and ( -d $file_folder or -f $file_folder ) ) {

      # Save current perms to an "undo" file
      system "/usr/local/bin/fsdiff -1 \"$file_folder\" | awk '{print \"chmod \" \$3 \" \" \"\\\"$file_folder\\\"\"}' >> $make_hidden_visible";

      system "/bin/chmod", "o-rwx", $file_folder;
      $hidden_stuff{$file_folder} = 1;
    }
  }

}

sub unhide_folders_files {
  my ( @unhide_list ) = @_;
  my $unhide_me;
  foreach $unhide_me ( @unhide_list ) {
    if ( -e $unhide_me ) {

      system "/usr/local/bin/SetFile", "-a", "v", $unhide_me;

    }
  }
}

sub hide_folders_files {
  my ( @hide_list ) = @_;
  my $hide_me;
  foreach $hide_me ( @hide_list ) {
    if ( -e $hide_me ) {

      system "/usr/local/bin/SetFile", "-a", "V", $hide_me;

    }
  }
}

1;
