#!/usr/bin/perl

################################################################################
# Copyright (c) 2008 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

if ( ! -e "/Library/LaunchAgents/edu.utah.scl.display_resolution.plist" ) {
	die "Can not load /Library/LaunchAgents/edu.utah.scl.display_resolution.plist because it is missing.\n";
}

while ( `launchctl list | grep edu.utah.scl.display_resolution` eq "" ) {
	sleep 1;
}

if ( system "launchctl", "start", "edu.utah.scl.display_resolution" ) {
	die "Launchd could not load edu.utah.scl.display_resolution: $!";
}
