#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

if ( -e $userHomeFolder ) {
  system "/Library/Xhooks/Modules/edu.utah.scl.home_folder/create_lost_and_found.pl";
}

################################################################################
# Make an empty home directory so that OS X doesn't try to create one for us
# at the next login (this started in 10.4).
if ( ! -e $userHomeFolder ) {
  mkdir $userHomeFolder;
}

exit 0;
