sub create_home_folder {
  my ($newfolder) = @_;
  #######################
  # Create the folder
  # create it in /tmp and move it to avoid incomplete copies that would result if 
  # this script were interupted (force restarted mac...)
  if ( ! -e $template_homefolder ) {
    entman_logger ( "log", "template_homefolder $template_homefolder is missing..." );
    return;
  }
  system "ditto", "-rsrcFork", $template_homefolder, $newfolder;
  system "/usr/local/bin/SetFile", "-a", "v", $newfolder;

  if ( -e "/$newfolder/Library/Preferences/dataComet Preferences" and defined $INTERNET_KIOSK and $INTERNET_KIOSK eq "True" ) {
#    system "chmod u+t \"$newfolder\""; 
#    system "chmod u+t \"$newfolder/Library\"";
#    system "chmod u+t \"$newfolder/Library/Preferences\""; 
#    system "chflags uchg \"$newfolder/Library/Preferences/dataComet Preferences\"";
  }

  $ms_office_fix = "$newfolder/Library/Preferences/Microsoft/Carbon Registration Database";
  if ( -e $ms_office_fix and defined $MS_OFFICE_CARBON_DB_DATE and $MS_OFFICE_CARBON_DB_DATE ne "" ) {
    system "/usr/local/bin/SetFile", "-d", $MS_OFFICE_CARBON_DB_DATE, $ms_office_fix;
    # Get the value of MS_OFFICE_CARBON_DB_DATE with:
    # "/Developer/Tools/GetFileInfo -d ~/Library/Preferences/Microsoft/Carbon\ Registration\ Database"
  }

  $ms_office_2004_fix = "$newfolder/Library/Preferences/Microsoft/OLE Registration Database 11";
  if ( -e $ms_office_2004_fix and defined $MS_OFFICE_OLE_DB_DATE and $MS_OFFICE_OLE_DB_DATE ne "" ) {
    system "/usr/local/bin/SetFile", "-d", $MS_OFFICE_OLE_DB_DATE, $ms_office_2004_fix;
    # Get the value of MS_OFFICE_OLE_DB_DATE with:
    # "/Developer/Tools/GetFileInfo -d ~/Library/Preferences/Microsoft/OLE\ Registration\ Database\ 11"
  }

}

1;
