#!/usr/bin/perl

################################################################################
# Copyright (c) 2005 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

use lib "/Library/Xhooks/Modules/";
require "xhooks/lib/config.pl";

if ( ! defined $ARGV[0] ) {
  entman_logger ( "log drawer", "No username specified!" );
  exit 1;
}

if ( $ARGV[0] eq $adminusername ) {
  restore_dock();
} else {
  if ( true_var ( $INTERNET_KIOSK ) ) {
    remove_dock();
  } else {
    restore_dock();
  }
}

sub remove_dock {
  system '/bin/mv -f /System/Library/CoreServices/Dock.app /System/Library/CoreServices/Doc.app';
}

sub restore_dock {
  if ( -e "/System/Library/CoreServices/Doc.app" ) {
    system '/bin/mv /System/Library/CoreServices/Doc.app /System/Library/CoreServices/Dock.app';
  }
}
