#!/usr/bin/perl

################################################################################
#
# Copyright (c) 2009 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
#
################################################################################

use lib "/Library/Xhooks/Modules";
require "xhooks/lib/config.pl";

if ( $ARGV[0] ne $ADMIN_USER_NAME and defined @MANUAL_AQUA_LAUNCHAGENTS and $#MANUAL_AQUA_LAUNCHAGENTS >= 0 ) {
  foreach $launchagent ( @MANUAL_AQUA_LAUNCHAGENTS ) {
    if ( -e $launchagent ) {
      #print "$0 launchctl load $launchagent\n";
      system "launchctl", "load", $launchagent;
    } else {
      print "ERROR: The launchagent $launchagent could not be loaded because it could not be found.\n";
    }
  }
} else { 
  #print "$0 Did not load launchagents because this failed: $ARGV[0] eq $KIOSK_USER_NAME and defined @MANUAL_AQUA_LAUNCHAGENTS and $#MANUAL_AQUA_LAUNCHAGENTS >= 0\n";
}
