#!/usr/bin/perl -w

################################################################################
# Copyright (c) 2008 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

if ( -f "/Library/Preferences/Xhooks/edu.utah.scl.radmind_xhooks_conf.perl" ) {
  use lib "/Library/Preferences/Xhooks";
  require "edu.utah.scl.radmind_xhooks_conf.perl";
} else {
  die "ERROR $0 - The file /Library/Preferences/Xhooks/edu.utah.scl.radmind_xhooks_conf.perl is missing and this script requires it!\n";
}

if ( ! defined $COMPUTER_VOLUME or $COMPUTER_VOLUME eq "" ) {
  die "ERROR $0 - The variable COMPUTER_VOLUME is not defined.";
}

print "$0 - osascript -e 'set volume $COMPUTER_VOLUME'\n" if ( defined $ENV{'xhooks_verbose'} and $ENV{'xhooks_verbose'});
system "osascript -e 'set volume $COMPUTER_VOLUME'";
