#!/usr/bin/perl

################################################################################
# Copyright (c) 2009 University of Utah Student Computing Labs.
# All Rights Reserved.
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appears in all copies and
# that both that copyright notice and this permission notice appear
# in supporting documentation, and that the name of The University
# of Utah not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission. This software is supplied as is without expressed or
# implied warranties of any kind.
################################################################################

if ( -e "/Library/Xhooks/Modules/xhooks/lib/config.pl" ) {
  use lib "/Library/Xhooks/Modules";
  require "xhooks/lib/config.pl";
} else {
  die "/Library/Xhooks/Modules/xhooks/lib/config.pl is missing or unreadable.";
}

sleep rand(5);

@IGNORE_SOFTWARE_UPDATE = (  
"061-5258-1.1.1", "HP Printer Drivers Update (1.1.1), 53614K",
"QuickTime-7.6", "QuickTime (7.6), 76880K",
"DVDorCDSharingSetup-1.1", "Migration and DVD  CD Sharing Update (1.1), 11350K",
"PAU200805-1.0", "Pro Applications Update 2008-05 (1.0), 24090K",
"FrontRowUpdate2.1.7-2.1.7", "Front Row Update (2.1.7), 13600K",
"iTunesX-8.1.1", "iTunes (8.1.1), 69670K",
"Safari3.2.1Leo-3.2.1", "Safari (3.2.1), 40859K",
"MacOSXUpd10.5.6-10.5.6", "Mac OS X Update (10.5.6), 195452K",
);

my $command = "softwareupdate --list";
if ( nonempty_array ( @IGNORE_SOFTWARE_UPDATE ) ) {
  foreach $grep_pattern ( @IGNORE_SOFTWARE_UPDATE ) {
    $command .= " | grep -v \"$grep_pattern\"";
  }
}

print "$command\n";
#print `$command`;
